// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rmf_task_msgs:action/DynamicEvent.idl
// generated code does not contain a copyright notice
#include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `category`
// Member `description`
#include "rosidl_runtime_c/string_functions.h"

bool
rmf_task_msgs__action__DynamicEvent_Goal__init(rmf_task_msgs__action__DynamicEvent_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // dynamic_event_seq
  // event_type
  // category
  if (!rosidl_runtime_c__String__init(&msg->category)) {
    rmf_task_msgs__action__DynamicEvent_Goal__fini(msg);
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__init(&msg->description)) {
    rmf_task_msgs__action__DynamicEvent_Goal__fini(msg);
    return false;
  }
  // id
  // stubborn_period
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Goal__fini(rmf_task_msgs__action__DynamicEvent_Goal * msg)
{
  if (!msg) {
    return;
  }
  // dynamic_event_seq
  // event_type
  // category
  rosidl_runtime_c__String__fini(&msg->category);
  // description
  rosidl_runtime_c__String__fini(&msg->description);
  // id
  // stubborn_period
}

bool
rmf_task_msgs__action__DynamicEvent_Goal__are_equal(const rmf_task_msgs__action__DynamicEvent_Goal * lhs, const rmf_task_msgs__action__DynamicEvent_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // dynamic_event_seq
  if (lhs->dynamic_event_seq != rhs->dynamic_event_seq) {
    return false;
  }
  // event_type
  if (lhs->event_type != rhs->event_type) {
    return false;
  }
  // category
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->category), &(rhs->category)))
  {
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->description), &(rhs->description)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // stubborn_period
  if (lhs->stubborn_period != rhs->stubborn_period) {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Goal__copy(
  const rmf_task_msgs__action__DynamicEvent_Goal * input,
  rmf_task_msgs__action__DynamicEvent_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // dynamic_event_seq
  output->dynamic_event_seq = input->dynamic_event_seq;
  // event_type
  output->event_type = input->event_type;
  // category
  if (!rosidl_runtime_c__String__copy(
      &(input->category), &(output->category)))
  {
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__copy(
      &(input->description), &(output->description)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // stubborn_period
  output->stubborn_period = input->stubborn_period;
  return true;
}

rmf_task_msgs__action__DynamicEvent_Goal *
rmf_task_msgs__action__DynamicEvent_Goal__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Goal * msg = (rmf_task_msgs__action__DynamicEvent_Goal *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_Goal));
  bool success = rmf_task_msgs__action__DynamicEvent_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_Goal__destroy(rmf_task_msgs__action__DynamicEvent_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__init(rmf_task_msgs__action__DynamicEvent_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Goal * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_Goal *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__fini(rmf_task_msgs__action__DynamicEvent_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_Goal__Sequence *
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Goal__Sequence * array = (rmf_task_msgs__action__DynamicEvent_Goal__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_Goal__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Goal__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_Goal__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_Goal * data =
      (rmf_task_msgs__action__DynamicEvent_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `execution_failure`
// Member `status`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
rmf_task_msgs__action__DynamicEvent_Result__init(rmf_task_msgs__action__DynamicEvent_Result * msg)
{
  if (!msg) {
    return false;
  }
  // execution_failure
  if (!rosidl_runtime_c__String__init(&msg->execution_failure)) {
    rmf_task_msgs__action__DynamicEvent_Result__fini(msg);
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__init(&msg->status)) {
    rmf_task_msgs__action__DynamicEvent_Result__fini(msg);
    return false;
  }
  // id
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Result__fini(rmf_task_msgs__action__DynamicEvent_Result * msg)
{
  if (!msg) {
    return;
  }
  // execution_failure
  rosidl_runtime_c__String__fini(&msg->execution_failure);
  // status
  rosidl_runtime_c__String__fini(&msg->status);
  // id
}

bool
rmf_task_msgs__action__DynamicEvent_Result__are_equal(const rmf_task_msgs__action__DynamicEvent_Result * lhs, const rmf_task_msgs__action__DynamicEvent_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // execution_failure
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->execution_failure), &(rhs->execution_failure)))
  {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->status), &(rhs->status)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Result__copy(
  const rmf_task_msgs__action__DynamicEvent_Result * input,
  rmf_task_msgs__action__DynamicEvent_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // execution_failure
  if (!rosidl_runtime_c__String__copy(
      &(input->execution_failure), &(output->execution_failure)))
  {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__copy(
      &(input->status), &(output->status)))
  {
    return false;
  }
  // id
  output->id = input->id;
  return true;
}

rmf_task_msgs__action__DynamicEvent_Result *
rmf_task_msgs__action__DynamicEvent_Result__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Result * msg = (rmf_task_msgs__action__DynamicEvent_Result *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_Result));
  bool success = rmf_task_msgs__action__DynamicEvent_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_Result__destroy(rmf_task_msgs__action__DynamicEvent_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_Result__Sequence__init(rmf_task_msgs__action__DynamicEvent_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Result * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_Result *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Result__Sequence__fini(rmf_task_msgs__action__DynamicEvent_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_Result__Sequence *
rmf_task_msgs__action__DynamicEvent_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Result__Sequence * array = (rmf_task_msgs__action__DynamicEvent_Result__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_Result__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_Result__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_Result__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Result__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_Result__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_Result * data =
      (rmf_task_msgs__action__DynamicEvent_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `status`
// already included above
// #include "rosidl_runtime_c/string_functions.h"
// Member `logs`
#include "rmf_task_msgs/msg/detail/log_entry__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_Feedback__init(rmf_task_msgs__action__DynamicEvent_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__init(&msg->status)) {
    rmf_task_msgs__action__DynamicEvent_Feedback__fini(msg);
    return false;
  }
  // id
  // logs
  if (!rmf_task_msgs__msg__LogEntry__Sequence__init(&msg->logs, 0)) {
    rmf_task_msgs__action__DynamicEvent_Feedback__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Feedback__fini(rmf_task_msgs__action__DynamicEvent_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // status
  rosidl_runtime_c__String__fini(&msg->status);
  // id
  // logs
  rmf_task_msgs__msg__LogEntry__Sequence__fini(&msg->logs);
}

bool
rmf_task_msgs__action__DynamicEvent_Feedback__are_equal(const rmf_task_msgs__action__DynamicEvent_Feedback * lhs, const rmf_task_msgs__action__DynamicEvent_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->status), &(rhs->status)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // logs
  if (!rmf_task_msgs__msg__LogEntry__Sequence__are_equal(
      &(lhs->logs), &(rhs->logs)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Feedback__copy(
  const rmf_task_msgs__action__DynamicEvent_Feedback * input,
  rmf_task_msgs__action__DynamicEvent_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__copy(
      &(input->status), &(output->status)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // logs
  if (!rmf_task_msgs__msg__LogEntry__Sequence__copy(
      &(input->logs), &(output->logs)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_Feedback *
rmf_task_msgs__action__DynamicEvent_Feedback__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Feedback * msg = (rmf_task_msgs__action__DynamicEvent_Feedback *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_Feedback));
  bool success = rmf_task_msgs__action__DynamicEvent_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_Feedback__destroy(rmf_task_msgs__action__DynamicEvent_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__init(rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Feedback * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_Feedback *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__fini(rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_Feedback__Sequence *
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * array = (rmf_task_msgs__action__DynamicEvent_Feedback__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_Feedback__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_Feedback * data =
      (rmf_task_msgs__action__DynamicEvent_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!rmf_task_msgs__action__DynamicEvent_Goal__init(&msg->goal)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  rmf_task_msgs__action__DynamicEvent_Goal__fini(&msg->goal);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Request * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!rmf_task_msgs__action__DynamicEvent_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Request * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!rmf_task_msgs__action__DynamicEvent_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Request *
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request * msg = (rmf_task_msgs__action__DynamicEvent_SendGoal_Request *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Request));
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_SendGoal_Request *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence *
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * array = (rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_SendGoal_Request * data =
      (rmf_task_msgs__action__DynamicEvent_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Response * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Response * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Response *
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response * msg = (rmf_task_msgs__action__DynamicEvent_SendGoal_Response *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Response));
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_SendGoal_Response *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence *
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * array = (rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_SendGoal_Response * data =
      (rmf_task_msgs__action__DynamicEvent_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(msg);
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__init(&msg->request, 0)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(msg);
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__init(&msg->response, 0)) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__fini(&msg->request);
  // response
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__fini(&msg->response);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Event * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Event * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Event *
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event * msg = (rmf_task_msgs__action__DynamicEvent_SendGoal_Event *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Event));
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__init(rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_SendGoal_Event *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__fini(rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence *
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * array = (rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_SendGoal_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_SendGoal_Event * data =
      (rmf_task_msgs__action__DynamicEvent_SendGoal_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_SendGoal_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_SendGoal_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__init(rmf_task_msgs__action__DynamicEvent_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Request * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Request * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_GetResult_Request *
rmf_task_msgs__action__DynamicEvent_GetResult_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Request * msg = (rmf_task_msgs__action__DynamicEvent_GetResult_Request *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Request));
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Request__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__init(rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Request * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_GetResult_Request *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence *
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * array = (rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_GetResult_Request * data =
      (rmf_task_msgs__action__DynamicEvent_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__init(rmf_task_msgs__action__DynamicEvent_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!rmf_task_msgs__action__DynamicEvent_Result__init(&msg->result)) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  rmf_task_msgs__action__DynamicEvent_Result__fini(&msg->result);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Response * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!rmf_task_msgs__action__DynamicEvent_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Response * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!rmf_task_msgs__action__DynamicEvent_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_GetResult_Response *
rmf_task_msgs__action__DynamicEvent_GetResult_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Response * msg = (rmf_task_msgs__action__DynamicEvent_GetResult_Response *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Response));
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Response__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__init(rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Response * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_GetResult_Response *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence *
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * array = (rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_GetResult_Response * data =
      (rmf_task_msgs__action__DynamicEvent_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
// already included above
// #include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__init(rmf_task_msgs__action__DynamicEvent_GetResult_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(msg);
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__init(&msg->request, 0)) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(msg);
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__init(&msg->response, 0)) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__fini(&msg->request);
  // response
  rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__fini(&msg->response);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Event * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Event * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_GetResult_Event *
rmf_task_msgs__action__DynamicEvent_GetResult_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Event * msg = (rmf_task_msgs__action__DynamicEvent_GetResult_Event *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Event));
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Event__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__init(rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Event * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_GetResult_Event *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__fini(rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence *
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * array = (rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_GetResult_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_GetResult_Event * data =
      (rmf_task_msgs__action__DynamicEvent_GetResult_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_GetResult_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_GetResult_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_GetResult_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__functions.h"

bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__init(rmf_task_msgs__action__DynamicEvent_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!rmf_task_msgs__action__DynamicEvent_Feedback__init(&msg->feedback)) {
    rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(rmf_task_msgs__action__DynamicEvent_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  rmf_task_msgs__action__DynamicEvent_Feedback__fini(&msg->feedback);
}

bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__are_equal(const rmf_task_msgs__action__DynamicEvent_FeedbackMessage * lhs, const rmf_task_msgs__action__DynamicEvent_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!rmf_task_msgs__action__DynamicEvent_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__copy(
  const rmf_task_msgs__action__DynamicEvent_FeedbackMessage * input,
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!rmf_task_msgs__action__DynamicEvent_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

rmf_task_msgs__action__DynamicEvent_FeedbackMessage *
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage * msg = (rmf_task_msgs__action__DynamicEvent_FeedbackMessage *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_task_msgs__action__DynamicEvent_FeedbackMessage));
  bool success = rmf_task_msgs__action__DynamicEvent_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__destroy(rmf_task_msgs__action__DynamicEvent_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__init(rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage * data = NULL;

  if (size) {
    data = (rmf_task_msgs__action__DynamicEvent_FeedbackMessage *)allocator.zero_allocate(size, sizeof(rmf_task_msgs__action__DynamicEvent_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_task_msgs__action__DynamicEvent_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__fini(rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence *
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * array = (rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence *)allocator.allocate(sizeof(rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__destroy(rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__are_equal(const rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * lhs, const rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence__copy(
  const rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * input,
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_task_msgs__action__DynamicEvent_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rmf_task_msgs__action__DynamicEvent_FeedbackMessage * data =
      (rmf_task_msgs__action__DynamicEvent_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_task_msgs__action__DynamicEvent_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rmf_task_msgs__action__DynamicEvent_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_task_msgs__action__DynamicEvent_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
