// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rmf_task_msgs:action/DynamicEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/action/dynamic_event.hpp"


#ifndef RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_HPP_
#define RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Goal __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Goal __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_Goal_
{
  using Type = DynamicEvent_Goal_<ContainerAllocator>;

  explicit DynamicEvent_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dynamic_event_seq = 0ul;
      this->event_type = 0ul;
      this->category = "";
      this->description = "";
      this->id = 0ull;
      this->stubborn_period = 0.0f;
    }
  }

  explicit DynamicEvent_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : category(_alloc),
    description(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dynamic_event_seq = 0ul;
      this->event_type = 0ul;
      this->category = "";
      this->description = "";
      this->id = 0ull;
      this->stubborn_period = 0.0f;
    }
  }

  // field types and members
  using _dynamic_event_seq_type =
    uint32_t;
  _dynamic_event_seq_type dynamic_event_seq;
  using _event_type_type =
    uint32_t;
  _event_type_type event_type;
  using _category_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _category_type category;
  using _description_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _description_type description;
  using _id_type =
    uint64_t;
  _id_type id;
  using _stubborn_period_type =
    float;
  _stubborn_period_type stubborn_period;

  // setters for named parameter idiom
  Type & set__dynamic_event_seq(
    const uint32_t & _arg)
  {
    this->dynamic_event_seq = _arg;
    return *this;
  }
  Type & set__event_type(
    const uint32_t & _arg)
  {
    this->event_type = _arg;
    return *this;
  }
  Type & set__category(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->category = _arg;
    return *this;
  }
  Type & set__description(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->description = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__stubborn_period(
    const float & _arg)
  {
    this->stubborn_period = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t EVENT_TYPE_UNINITIALIZED =
    0u;
  static constexpr uint32_t EVENT_TYPE_NEXT =
    1u;
  static constexpr uint32_t EVENT_TYPE_CANCEL =
    2u;
  static constexpr uint32_t EVENT_TYPE_FINISHED =
    3u;

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Goal
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Goal
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_Goal_ & other) const
  {
    if (this->dynamic_event_seq != other.dynamic_event_seq) {
      return false;
    }
    if (this->event_type != other.event_type) {
      return false;
    }
    if (this->category != other.category) {
      return false;
    }
    if (this->description != other.description) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->stubborn_period != other.stubborn_period) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_Goal_

// alias to use template instance with default allocator
using DynamicEvent_Goal =
  rmf_task_msgs::action::DynamicEvent_Goal_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t DynamicEvent_Goal_<ContainerAllocator>::EVENT_TYPE_UNINITIALIZED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t DynamicEvent_Goal_<ContainerAllocator>::EVENT_TYPE_NEXT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t DynamicEvent_Goal_<ContainerAllocator>::EVENT_TYPE_CANCEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t DynamicEvent_Goal_<ContainerAllocator>::EVENT_TYPE_FINISHED;
#endif  // __cplusplus < 201703L

}  // namespace action

}  // namespace rmf_task_msgs


#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Result __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Result __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_Result_
{
  using Type = DynamicEvent_Result_<ContainerAllocator>;

  explicit DynamicEvent_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->execution_failure = "";
      this->status = "";
      this->id = 0ull;
    }
  }

  explicit DynamicEvent_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : execution_failure(_alloc),
    status(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->execution_failure = "";
      this->status = "";
      this->id = 0ull;
    }
  }

  // field types and members
  using _execution_failure_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _execution_failure_type execution_failure;
  using _status_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _status_type status;
  using _id_type =
    uint64_t;
  _id_type id;

  // setters for named parameter idiom
  Type & set__execution_failure(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->execution_failure = _arg;
    return *this;
  }
  Type & set__status(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Result
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Result
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_Result_ & other) const
  {
    if (this->execution_failure != other.execution_failure) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_Result_

// alias to use template instance with default allocator
using DynamicEvent_Result =
  rmf_task_msgs::action::DynamicEvent_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'logs'
#include "rmf_task_msgs/msg/detail/log_entry__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_Feedback __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_Feedback_
{
  using Type = DynamicEvent_Feedback_<ContainerAllocator>;

  explicit DynamicEvent_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = "";
      this->id = 0ull;
    }
  }

  explicit DynamicEvent_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : status(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = "";
      this->id = 0ull;
    }
  }

  // field types and members
  using _status_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _status_type status;
  using _id_type =
    uint64_t;
  _id_type id;
  using _logs_type =
    std::vector<rmf_task_msgs::msg::LogEntry_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::msg::LogEntry_<ContainerAllocator>>>;
  _logs_type logs;

  // setters for named parameter idiom
  Type & set__status(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__logs(
    const std::vector<rmf_task_msgs::msg::LogEntry_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::msg::LogEntry_<ContainerAllocator>>> & _arg)
  {
    this->logs = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Feedback
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_Feedback
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_Feedback_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->logs != other.logs) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_Feedback_

// alias to use template instance with default allocator
using DynamicEvent_Feedback =
  rmf_task_msgs::action::DynamicEvent_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "rmf_task_msgs/action/detail/dynamic_event__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Request __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_SendGoal_Request_
{
  using Type = DynamicEvent_SendGoal_Request_<ContainerAllocator>;

  explicit DynamicEvent_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit DynamicEvent_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const rmf_task_msgs::action::DynamicEvent_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Request
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Request
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_SendGoal_Request_

// alias to use template instance with default allocator
using DynamicEvent_SendGoal_Request =
  rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Response __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_SendGoal_Response_
{
  using Type = DynamicEvent_SendGoal_Response_<ContainerAllocator>;

  explicit DynamicEvent_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit DynamicEvent_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Response
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Response
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_SendGoal_Response_

// alias to use template instance with default allocator
using DynamicEvent_SendGoal_Response =
  rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Event __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Event __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_SendGoal_Event_
{
  using Type = DynamicEvent_SendGoal_Event_<ContainerAllocator>;

  explicit DynamicEvent_SendGoal_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit DynamicEvent_SendGoal_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_SendGoal_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_SendGoal_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Event
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_SendGoal_Event
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_SendGoal_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_SendGoal_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_SendGoal_Event_

// alias to use template instance with default allocator
using DynamicEvent_SendGoal_Event =
  rmf_task_msgs::action::DynamicEvent_SendGoal_Event_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs

namespace rmf_task_msgs
{

namespace action
{

struct DynamicEvent_SendGoal
{
  using Request = rmf_task_msgs::action::DynamicEvent_SendGoal_Request;
  using Response = rmf_task_msgs::action::DynamicEvent_SendGoal_Response;
  using Event = rmf_task_msgs::action::DynamicEvent_SendGoal_Event;
};

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Request __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_GetResult_Request_
{
  using Type = DynamicEvent_GetResult_Request_<ContainerAllocator>;

  explicit DynamicEvent_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit DynamicEvent_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Request
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Request
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_GetResult_Request_

// alias to use template instance with default allocator
using DynamicEvent_GetResult_Request =
  rmf_task_msgs::action::DynamicEvent_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'result'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Response __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_GetResult_Response_
{
  using Type = DynamicEvent_GetResult_Response_<ContainerAllocator>;

  explicit DynamicEvent_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit DynamicEvent_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const rmf_task_msgs::action::DynamicEvent_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Response
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Response
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_GetResult_Response_

// alias to use template instance with default allocator
using DynamicEvent_GetResult_Response =
  rmf_task_msgs::action::DynamicEvent_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Event __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Event __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_GetResult_Event_
{
  using Type = DynamicEvent_GetResult_Event_<ContainerAllocator>;

  explicit DynamicEvent_GetResult_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit DynamicEvent_GetResult_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_GetResult_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rmf_task_msgs::action::DynamicEvent_GetResult_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Event
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_GetResult_Event
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_GetResult_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_GetResult_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_GetResult_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_GetResult_Event_

// alias to use template instance with default allocator
using DynamicEvent_GetResult_Event =
  rmf_task_msgs::action::DynamicEvent_GetResult_Event_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs

namespace rmf_task_msgs
{

namespace action
{

struct DynamicEvent_GetResult
{
  using Request = rmf_task_msgs::action::DynamicEvent_GetResult_Request;
  using Response = rmf_task_msgs::action::DynamicEvent_GetResult_Response;
  using Event = rmf_task_msgs::action::DynamicEvent_GetResult_Event;
};

}  // namespace action

}  // namespace rmf_task_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__action__DynamicEvent_FeedbackMessage __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct DynamicEvent_FeedbackMessage_
{
  using Type = DynamicEvent_FeedbackMessage_<ContainerAllocator>;

  explicit DynamicEvent_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit DynamicEvent_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const rmf_task_msgs::action::DynamicEvent_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_FeedbackMessage
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__action__DynamicEvent_FeedbackMessage
    std::shared_ptr<rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEvent_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEvent_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEvent_FeedbackMessage_

// alias to use template instance with default allocator
using DynamicEvent_FeedbackMessage =
  rmf_task_msgs::action::DynamicEvent_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rmf_task_msgs

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace rmf_task_msgs
{

namespace action
{

struct DynamicEvent
{
  /// The goal message defined in the action definition.
  using Goal = rmf_task_msgs::action::DynamicEvent_Goal;
  /// The result message defined in the action definition.
  using Result = rmf_task_msgs::action::DynamicEvent_Result;
  /// The feedback message defined in the action definition.
  using Feedback = rmf_task_msgs::action::DynamicEvent_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = rmf_task_msgs::action::DynamicEvent_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = rmf_task_msgs::action::DynamicEvent_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = rmf_task_msgs::action::DynamicEvent_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct DynamicEvent DynamicEvent;

}  // namespace action

}  // namespace rmf_task_msgs

#endif  // RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_HPP_
