// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_task_msgs:action/DynamicEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/action/dynamic_event.hpp"


#ifndef RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__TRAITS_HPP_
#define RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rmf_task_msgs/action/detail/dynamic_event__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: dynamic_event_seq
  {
    out << "dynamic_event_seq: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_event_seq, out);
    out << ", ";
  }

  // member: event_type
  {
    out << "event_type: ";
    rosidl_generator_traits::value_to_yaml(msg.event_type, out);
    out << ", ";
  }

  // member: category
  {
    out << "category: ";
    rosidl_generator_traits::value_to_yaml(msg.category, out);
    out << ", ";
  }

  // member: description
  {
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: stubborn_period
  {
    out << "stubborn_period: ";
    rosidl_generator_traits::value_to_yaml(msg.stubborn_period, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: dynamic_event_seq
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamic_event_seq: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_event_seq, out);
    out << "\n";
  }

  // member: event_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_type: ";
    rosidl_generator_traits::value_to_yaml(msg.event_type, out);
    out << "\n";
  }

  // member: category
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "category: ";
    rosidl_generator_traits::value_to_yaml(msg.category, out);
    out << "\n";
  }

  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: stubborn_period
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stubborn_period: ";
    rosidl_generator_traits::value_to_yaml(msg.stubborn_period, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_Goal & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_Goal>()
{
  return "rmf_task_msgs::action::DynamicEvent_Goal";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_Goal>()
{
  return "rmf_task_msgs/action/DynamicEvent_Goal";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: execution_failure
  {
    out << "execution_failure: ";
    rosidl_generator_traits::value_to_yaml(msg.execution_failure, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: execution_failure
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "execution_failure: ";
    rosidl_generator_traits::value_to_yaml(msg.execution_failure, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_Result & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_Result>()
{
  return "rmf_task_msgs::action::DynamicEvent_Result";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_Result>()
{
  return "rmf_task_msgs/action/DynamicEvent_Result";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'logs'
#include "rmf_task_msgs/msg/detail/log_entry__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: logs
  {
    if (msg.logs.size() == 0) {
      out << "logs: []";
    } else {
      out << "logs: [";
      size_t pending_items = msg.logs.size();
      for (auto item : msg.logs) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: logs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.logs.size() == 0) {
      out << "logs: []\n";
    } else {
      out << "logs:\n";
      for (auto item : msg.logs) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_Feedback & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_Feedback>()
{
  return "rmf_task_msgs::action::DynamicEvent_Feedback";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_Feedback>()
{
  return "rmf_task_msgs/action/DynamicEvent_Feedback";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "rmf_task_msgs/action/detail/dynamic_event__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_SendGoal_Request & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>()
{
  return "rmf_task_msgs::action::DynamicEvent_SendGoal_Request";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>()
{
  return "rmf_task_msgs/action/DynamicEvent_SendGoal_Request";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<rmf_task_msgs::action::DynamicEvent_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<rmf_task_msgs::action::DynamicEvent_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_SendGoal_Response & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>()
{
  return "rmf_task_msgs::action::DynamicEvent_SendGoal_Response";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>()
{
  return "rmf_task_msgs/action/DynamicEvent_SendGoal_Response";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_SendGoal_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_SendGoal_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_SendGoal_Event & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_SendGoal_Event>()
{
  return "rmf_task_msgs::action::DynamicEvent_SendGoal_Event";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_SendGoal_Event>()
{
  return "rmf_task_msgs/action/DynamicEvent_SendGoal_Event";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Event>
  : std::integral_constant<bool, has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>::value && has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_SendGoal_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_SendGoal>()
{
  return "rmf_task_msgs::action::DynamicEvent_SendGoal";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_SendGoal>()
{
  return "rmf_task_msgs/action/DynamicEvent_SendGoal";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>::value &&
    has_fixed_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>::value &&
    has_bounded_size<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<rmf_task_msgs::action::DynamicEvent_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<rmf_task_msgs::action::DynamicEvent_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rmf_task_msgs::action::DynamicEvent_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_GetResult_Request & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_GetResult_Request>()
{
  return "rmf_task_msgs::action::DynamicEvent_GetResult_Request";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_GetResult_Request>()
{
  return "rmf_task_msgs/action/DynamicEvent_GetResult_Request";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_GetResult_Response & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_GetResult_Response>()
{
  return "rmf_task_msgs::action::DynamicEvent_GetResult_Response";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_GetResult_Response>()
{
  return "rmf_task_msgs/action/DynamicEvent_GetResult_Response";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<rmf_task_msgs::action::DynamicEvent_Result>::value> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<rmf_task_msgs::action::DynamicEvent_Result>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_GetResult_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_GetResult_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_GetResult_Event & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_GetResult_Event>()
{
  return "rmf_task_msgs::action::DynamicEvent_GetResult_Event";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_GetResult_Event>()
{
  return "rmf_task_msgs/action/DynamicEvent_GetResult_Event";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Event>
  : std::integral_constant<bool, has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Request>::value && has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_GetResult_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_GetResult>()
{
  return "rmf_task_msgs::action::DynamicEvent_GetResult";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_GetResult>()
{
  return "rmf_task_msgs/action/DynamicEvent_GetResult";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult_Request>::value &&
    has_fixed_size<rmf_task_msgs::action::DynamicEvent_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Request>::value &&
    has_bounded_size<rmf_task_msgs::action::DynamicEvent_GetResult_Response>::value
  >
{
};

template<>
struct is_service<rmf_task_msgs::action::DynamicEvent_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<rmf_task_msgs::action::DynamicEvent_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rmf_task_msgs::action::DynamicEvent_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__traits.hpp"

namespace rmf_task_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const DynamicEvent_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEvent_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEvent_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::action::DynamicEvent_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::action::DynamicEvent_FeedbackMessage & msg)
{
  return rmf_task_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent_FeedbackMessage>()
{
  return "rmf_task_msgs::action::DynamicEvent_FeedbackMessage";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent_FeedbackMessage>()
{
  return "rmf_task_msgs/action/DynamicEvent_FeedbackMessage";
}

template<>
struct has_fixed_size<rmf_task_msgs::action::DynamicEvent_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<rmf_task_msgs::action::DynamicEvent_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rmf_task_msgs::action::DynamicEvent_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<rmf_task_msgs::action::DynamicEvent_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rmf_task_msgs::action::DynamicEvent_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rmf_task_msgs::action::DynamicEvent>()
{
  return "rmf_task_msgs::action::DynamicEvent";
}

template<>
inline const char * name<rmf_task_msgs::action::DynamicEvent>()
{
  return "rmf_task_msgs/action/DynamicEvent";
}

template<>
struct is_action<rmf_task_msgs::action::DynamicEvent>
  : std::true_type
{
};

template<>
struct is_action_goal<rmf_task_msgs::action::DynamicEvent_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<rmf_task_msgs::action::DynamicEvent_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<rmf_task_msgs::action::DynamicEvent_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__TRAITS_HPP_
