// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rmf_task_msgs:msg/DynamicEventDescription.idl
// generated code does not contain a copyright notice

#include "rmf_task_msgs/msg/detail/dynamic_event_description__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rmf_task_msgs
const rosidl_type_hash_t *
rmf_task_msgs__msg__DynamicEventDescription__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xfa, 0x4c, 0x62, 0x65, 0x90, 0x43, 0xfd, 0xd4,
      0xd8, 0xe1, 0x59, 0x32, 0x75, 0xf4, 0xba, 0x39,
      0xc5, 0xeb, 0x2a, 0x04, 0x44, 0xaa, 0x38, 0x5c,
      0x22, 0xd6, 0xd4, 0x08, 0xb3, 0x44, 0x91, 0xaf,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char rmf_task_msgs__msg__DynamicEventDescription__TYPE_NAME[] = "rmf_task_msgs/msg/DynamicEventDescription";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__fleet[] = "fleet";
static char rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__robot[] = "robot";
static char rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__dynamic_event_seq[] = "dynamic_event_seq";
static char rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__description[] = "description";
static char rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__start_time[] = "start_time";

static rosidl_runtime_c__type_description__Field rmf_task_msgs__msg__DynamicEventDescription__FIELDS[] = {
  {
    {rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__fleet, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__robot, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__dynamic_event_seq, 17, 17},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__description, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventDescription__FIELD_NAME__start_time, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription rmf_task_msgs__msg__DynamicEventDescription__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rmf_task_msgs__msg__DynamicEventDescription__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rmf_task_msgs__msg__DynamicEventDescription__TYPE_NAME, 41, 41},
      {rmf_task_msgs__msg__DynamicEventDescription__FIELDS, 5, 5},
    },
    {rmf_task_msgs__msg__DynamicEventDescription__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Published to both of the topics:\n"
  "# rmf/dynamic_event/begin\n"
  "# rmf/dynamic_event/begin/<fleet_name>/<robot_name>\n"
  "\n"
  "# Name of the fleet of the robot beginning the dynamic event.\n"
  "string fleet\n"
  "\n"
  "# Name of the robot beginning the dynamic event.\n"
  "string robot\n"
  "\n"
  "# The sequence number for this dynamic event. This is unique for each run of a\n"
  "# dynamic event within one robot.\n"
  "#\n"
  "# Each new run of a dynamic event for a robot will increment this value until it\n"
  "# reaches integer overflow and goes back to 0.\n"
  "uint32 dynamic_event_seq\n"
  "\n"
  "# Full JSON description of the dynamic event, including the estimate field\n"
  "# and any custom fields put in by the task request.\n"
  "string description\n"
  "\n"
  "# What time the dynamic event started.\n"
  "builtin_interfaces/Time start_time";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rmf_task_msgs__msg__DynamicEventDescription__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rmf_task_msgs__msg__DynamicEventDescription__TYPE_NAME, 41, 41},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 743, 743},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rmf_task_msgs__msg__DynamicEventDescription__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rmf_task_msgs__msg__DynamicEventDescription__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
