// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rmf_task_msgs:msg/DynamicEventDescription.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/dynamic_event_description.hpp"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_HPP_
#define RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start_time'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__msg__DynamicEventDescription __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__msg__DynamicEventDescription __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DynamicEventDescription_
{
  using Type = DynamicEventDescription_<ContainerAllocator>;

  explicit DynamicEventDescription_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fleet = "";
      this->robot = "";
      this->dynamic_event_seq = 0ul;
      this->description = "";
    }
  }

  explicit DynamicEventDescription_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : fleet(_alloc),
    robot(_alloc),
    description(_alloc),
    start_time(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fleet = "";
      this->robot = "";
      this->dynamic_event_seq = 0ul;
      this->description = "";
    }
  }

  // field types and members
  using _fleet_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _fleet_type fleet;
  using _robot_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_type robot;
  using _dynamic_event_seq_type =
    uint32_t;
  _dynamic_event_seq_type dynamic_event_seq;
  using _description_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _description_type description;
  using _start_time_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _start_time_type start_time;

  // setters for named parameter idiom
  Type & set__fleet(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->fleet = _arg;
    return *this;
  }
  Type & set__robot(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot = _arg;
    return *this;
  }
  Type & set__dynamic_event_seq(
    const uint32_t & _arg)
  {
    this->dynamic_event_seq = _arg;
    return *this;
  }
  Type & set__description(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->description = _arg;
    return *this;
  }
  Type & set__start_time(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->start_time = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__msg__DynamicEventDescription
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__msg__DynamicEventDescription
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventDescription_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEventDescription_ & other) const
  {
    if (this->fleet != other.fleet) {
      return false;
    }
    if (this->robot != other.robot) {
      return false;
    }
    if (this->dynamic_event_seq != other.dynamic_event_seq) {
      return false;
    }
    if (this->description != other.description) {
      return false;
    }
    if (this->start_time != other.start_time) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEventDescription_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEventDescription_

// alias to use template instance with default allocator
using DynamicEventDescription =
  rmf_task_msgs::msg::DynamicEventDescription_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rmf_task_msgs

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_HPP_
