// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rmf_task_msgs:msg/DynamicEventStatus.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/dynamic_event_status.hpp"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_HPP_
#define RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'time'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rmf_task_msgs__msg__DynamicEventStatus __attribute__((deprecated))
#else
# define DEPRECATED__rmf_task_msgs__msg__DynamicEventStatus __declspec(deprecated)
#endif

namespace rmf_task_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DynamicEventStatus_
{
  using Type = DynamicEventStatus_<ContainerAllocator>;

  explicit DynamicEventStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dynamic_event_seq = 0ul;
      this->dynamic_state = 0;
      this->status = "";
      this->id = 0ull;
    }
  }

  explicit DynamicEventStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : status(_alloc),
    time(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dynamic_event_seq = 0ul;
      this->dynamic_state = 0;
      this->status = "";
      this->id = 0ull;
    }
  }

  // field types and members
  using _dynamic_event_seq_type =
    uint32_t;
  _dynamic_event_seq_type dynamic_event_seq;
  using _dynamic_state_type =
    uint8_t;
  _dynamic_state_type dynamic_state;
  using _status_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _status_type status;
  using _id_type =
    uint64_t;
  _id_type id;
  using _time_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _time_type time;

  // setters for named parameter idiom
  Type & set__dynamic_event_seq(
    const uint32_t & _arg)
  {
    this->dynamic_event_seq = _arg;
    return *this;
  }
  Type & set__dynamic_state(
    const uint8_t & _arg)
  {
    this->dynamic_state = _arg;
    return *this;
  }
  Type & set__status(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__time(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->time = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t DYNAMIC_STATE_INACTIVE =
    0u;
  static constexpr uint8_t DYNAMIC_STATE_WAITING =
    1u;
  static constexpr uint8_t DYNAMIC_STATE_RUNNING =
    2u;

  // pointer types
  using RawPtr =
    rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rmf_task_msgs__msg__DynamicEventStatus
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rmf_task_msgs__msg__DynamicEventStatus
    std::shared_ptr<rmf_task_msgs::msg::DynamicEventStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicEventStatus_ & other) const
  {
    if (this->dynamic_event_seq != other.dynamic_event_seq) {
      return false;
    }
    if (this->dynamic_state != other.dynamic_state) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicEventStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicEventStatus_

// alias to use template instance with default allocator
using DynamicEventStatus =
  rmf_task_msgs::msg::DynamicEventStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DynamicEventStatus_<ContainerAllocator>::DYNAMIC_STATE_INACTIVE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DynamicEventStatus_<ContainerAllocator>::DYNAMIC_STATE_WAITING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DynamicEventStatus_<ContainerAllocator>::DYNAMIC_STATE_RUNNING;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace rmf_task_msgs

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_HPP_
