// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rmf_task_msgs:msg/LogEntry.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/log_entry.h"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__LOG_ENTRY__STRUCT_H_
#define RMF_TASK_MSGS__MSG__DETAIL__LOG_ENTRY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'TIER_UNINITIALIZED'.
static const char * const rmf_task_msgs__msg__LogEntry__TIER_UNINITIALIZED = "uninitialized";

/// Constant 'TIER_INFO'.
static const char * const rmf_task_msgs__msg__LogEntry__TIER_INFO = "info";

/// Constant 'TIER_WARNING'.
static const char * const rmf_task_msgs__msg__LogEntry__TIER_WARNING = "warning";

/// Constant 'TIER_ERROR'.
static const char * const rmf_task_msgs__msg__LogEntry__TIER_ERROR = "error";

// Include directives for member types
// Member 'tier'
// Member 'text'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/LogEntry in the package rmf_task_msgs.
/**
  * This is a ROS message definition that matches the log_entry.json schema:
  * https://github.com/open-rmf/rmf_api_msgs/blob/main/rmf_api_msgs/schemas/log_entry.json
 */
typedef struct rmf_task_msgs__msg__LogEntry
{
  /// Sequence number for this entry. Each entry has a unique sequence number which
  /// monotonically increase, until integer overflow causes a wrap around.
  uint32_t seq;
  /// The importance level of the log entry. Must be one of:
  /// * TIER_UNINITIALIZED
  /// * TIER_INFO
  /// * TIER_WARNING
  /// * TIER_ERROR
  rosidl_runtime_c__String tier;
  /// The timestamp of this log entry in the number of milliseconds since the beginning
  /// of the Unix epoch. We use this instead of builtin_interfaces/Time to perfectly
  /// match the log_entry.json schema.
  int64_t unix_millis_time;
  /// The text of the log entry
  rosidl_runtime_c__String text;
} rmf_task_msgs__msg__LogEntry;

// Struct for a sequence of rmf_task_msgs__msg__LogEntry.
typedef struct rmf_task_msgs__msg__LogEntry__Sequence
{
  rmf_task_msgs__msg__LogEntry * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__msg__LogEntry__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RMF_TASK_MSGS__MSG__DETAIL__LOG_ENTRY__STRUCT_H_
