// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rmf_task_msgs:msg/DynamicEventDescription.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/dynamic_event_description.h"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_H_
#define RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'fleet'
// Member 'robot'
// Member 'description'
#include "rosidl_runtime_c/string.h"
// Member 'start_time'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in msg/DynamicEventDescription in the package rmf_task_msgs.
/**
  * Published to both of the topics:
  * rmf/dynamic_event/begin
  * rmf/dynamic_event/begin/<fleet_name>/<robot_name>
 */
typedef struct rmf_task_msgs__msg__DynamicEventDescription
{
  /// Name of the fleet of the robot beginning the dynamic event.
  rosidl_runtime_c__String fleet;
  /// Name of the robot beginning the dynamic event.
  rosidl_runtime_c__String robot;
  /// The sequence number for this dynamic event. This is unique for each run of a
  /// dynamic event within one robot.
  ///
  /// Each new run of a dynamic event for a robot will increment this value until it
  /// reaches integer overflow and goes back to 0.
  uint32_t dynamic_event_seq;
  /// Full JSON description of the dynamic event, including the estimate field
  /// and any custom fields put in by the task request.
  rosidl_runtime_c__String description;
  /// What time the dynamic event started.
  builtin_interfaces__msg__Time start_time;
} rmf_task_msgs__msg__DynamicEventDescription;

// Struct for a sequence of rmf_task_msgs__msg__DynamicEventDescription.
typedef struct rmf_task_msgs__msg__DynamicEventDescription__Sequence
{
  rmf_task_msgs__msg__DynamicEventDescription * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__msg__DynamicEventDescription__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__STRUCT_H_
