// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_task_msgs:msg/DynamicEventDescription.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/dynamic_event_description.hpp"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__TRAITS_HPP_
#define RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rmf_task_msgs/msg/detail/dynamic_event_description__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start_time'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace rmf_task_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DynamicEventDescription & msg,
  std::ostream & out)
{
  out << "{";
  // member: fleet
  {
    out << "fleet: ";
    rosidl_generator_traits::value_to_yaml(msg.fleet, out);
    out << ", ";
  }

  // member: robot
  {
    out << "robot: ";
    rosidl_generator_traits::value_to_yaml(msg.robot, out);
    out << ", ";
  }

  // member: dynamic_event_seq
  {
    out << "dynamic_event_seq: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_event_seq, out);
    out << ", ";
  }

  // member: description
  {
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << ", ";
  }

  // member: start_time
  {
    out << "start_time: ";
    to_flow_style_yaml(msg.start_time, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DynamicEventDescription & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: fleet
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fleet: ";
    rosidl_generator_traits::value_to_yaml(msg.fleet, out);
    out << "\n";
  }

  // member: robot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot: ";
    rosidl_generator_traits::value_to_yaml(msg.robot, out);
    out << "\n";
  }

  // member: dynamic_event_seq
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamic_event_seq: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_event_seq, out);
    out << "\n";
  }

  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << "\n";
  }

  // member: start_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_time:\n";
    to_block_style_yaml(msg.start_time, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DynamicEventDescription & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rmf_task_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rmf_task_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rmf_task_msgs::msg::DynamicEventDescription & msg,
  std::ostream & out, size_t indentation = 0)
{
  rmf_task_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rmf_task_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rmf_task_msgs::msg::DynamicEventDescription & msg)
{
  return rmf_task_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rmf_task_msgs::msg::DynamicEventDescription>()
{
  return "rmf_task_msgs::msg::DynamicEventDescription";
}

template<>
inline const char * name<rmf_task_msgs::msg::DynamicEventDescription>()
{
  return "rmf_task_msgs/msg/DynamicEventDescription";
}

template<>
struct has_fixed_size<rmf_task_msgs::msg::DynamicEventDescription>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::msg::DynamicEventDescription>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::msg::DynamicEventDescription>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_DESCRIPTION__TRAITS_HPP_
