// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rmf_task_msgs:msg/DynamicEventStatus.idl
// generated code does not contain a copyright notice

#include "rmf_task_msgs/msg/detail/dynamic_event_status__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rmf_task_msgs
const rosidl_type_hash_t *
rmf_task_msgs__msg__DynamicEventStatus__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x11, 0x59, 0xfb, 0x2a, 0xd0, 0x62, 0x11, 0xfc,
      0x87, 0x5c, 0xa5, 0x65, 0x5a, 0x22, 0xd2, 0x0c,
      0x96, 0x7e, 0x2b, 0xf3, 0x9e, 0x7c, 0x8e, 0x81,
      0xe0, 0xfb, 0xe9, 0x3a, 0x2e, 0xf2, 0x8f, 0x0e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char rmf_task_msgs__msg__DynamicEventStatus__TYPE_NAME[] = "rmf_task_msgs/msg/DynamicEventStatus";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__dynamic_event_seq[] = "dynamic_event_seq";
static char rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__dynamic_state[] = "dynamic_state";
static char rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__status[] = "status";
static char rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__id[] = "id";
static char rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__time[] = "time";

static rosidl_runtime_c__type_description__Field rmf_task_msgs__msg__DynamicEventStatus__FIELDS[] = {
  {
    {rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__dynamic_event_seq, 17, 17},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__dynamic_state, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__status, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__id, 2, 2},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__DynamicEventStatus__FIELD_NAME__time, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription rmf_task_msgs__msg__DynamicEventStatus__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rmf_task_msgs__msg__DynamicEventStatus__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rmf_task_msgs__msg__DynamicEventStatus__TYPE_NAME, 36, 36},
      {rmf_task_msgs__msg__DynamicEventStatus__FIELDS, 5, 5},
    },
    {rmf_task_msgs__msg__DynamicEventStatus__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Published to the topic\n"
  "# rmf/dynamic_event/status/<fleet_name>/<robot_name>\n"
  "\n"
  "# The sequence number for this dynamic event. This is unique for each run of a\n"
  "# dynamic event within one robot.\n"
  "#\n"
  "# Each new run of a dynamic event for a robot will increment this value until it\n"
  "# reaches integer overflow and goes back to 0.\n"
  "uint32 dynamic_event_seq\n"
  "\n"
  "# Current state of dynamic event execution for the robot associated with the\n"
  "# topic that this is being published to.\n"
  "uint8 dynamic_state\n"
  "\n"
  "# There is no dynamic event running right now. Any DynamicEvent action requests\n"
  "# will be rejected in this state.\n"
  "uint8 DYNAMIC_STATE_INACTIVE = 0\n"
  "\n"
  "# The dynamic event is waiting for its next command. In this state it would be\n"
  "# valid to issue a DynamicEvent action request.\n"
  "uint8 DYNAMIC_STATE_WAITING = 1\n"
  "\n"
  "# The dynamic event is running a command right now. Any DynamicEvent action\n"
  "# requests will be rejected in this state.\n"
  "uint8 DYNAMIC_STATE_RUNNING = 2\n"
  "\n"
  "# If the dynamic_state is DYNAMIC_STATE_RUNNING, then this will be the current\n"
  "# status of the action. This string will match one of the values in the \"status\" schema:\n"
  "# https://github.com/open-rmf/rmf_api_msgs/rmf_api_msgs/schemas/task_state.json\n"
  "string status\n"
  "\n"
  "# If the dynamic_state is DYNAMIC_STATE_RUNNING, then this will be The ID of the\n"
  "# current sub-event within the dynamic event.\n"
  "uint64 id\n"
  "\n"
  "# Timestamp for when this status change occurred.\n"
  "builtin_interfaces/Time time";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rmf_task_msgs__msg__DynamicEventStatus__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rmf_task_msgs__msg__DynamicEventStatus__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1427, 1427},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rmf_task_msgs__msg__DynamicEventStatus__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rmf_task_msgs__msg__DynamicEventStatus__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
