// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rmf_task_msgs:msg/LogEntry.idl
// generated code does not contain a copyright notice

#include "rmf_task_msgs/msg/detail/log_entry__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rmf_task_msgs
const rosidl_type_hash_t *
rmf_task_msgs__msg__LogEntry__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x21, 0x76, 0xd2, 0x92, 0x6b, 0xf1, 0xb0, 0x5f,
      0x6e, 0x9e, 0x39, 0x9e, 0xdb, 0x98, 0x4c, 0x10,
      0x5d, 0x22, 0x72, 0x15, 0x49, 0x11, 0x9b, 0x7d,
      0x09, 0x5b, 0x34, 0xfc, 0x35, 0xfe, 0x08, 0x9a,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rmf_task_msgs__msg__LogEntry__TYPE_NAME[] = "rmf_task_msgs/msg/LogEntry";

// Define type names, field names, and default values
static char rmf_task_msgs__msg__LogEntry__FIELD_NAME__seq[] = "seq";
static char rmf_task_msgs__msg__LogEntry__FIELD_NAME__tier[] = "tier";
static char rmf_task_msgs__msg__LogEntry__FIELD_NAME__unix_millis_time[] = "unix_millis_time";
static char rmf_task_msgs__msg__LogEntry__FIELD_NAME__text[] = "text";

static rosidl_runtime_c__type_description__Field rmf_task_msgs__msg__LogEntry__FIELDS[] = {
  {
    {rmf_task_msgs__msg__LogEntry__FIELD_NAME__seq, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__LogEntry__FIELD_NAME__tier, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__LogEntry__FIELD_NAME__unix_millis_time, 16, 16},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rmf_task_msgs__msg__LogEntry__FIELD_NAME__text, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rmf_task_msgs__msg__LogEntry__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rmf_task_msgs__msg__LogEntry__TYPE_NAME, 26, 26},
      {rmf_task_msgs__msg__LogEntry__FIELDS, 4, 4},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# This is a ROS message definition that matches the log_entry.json schema:\n"
  "# https://github.com/open-rmf/rmf_api_msgs/blob/main/rmf_api_msgs/schemas/log_entry.json\n"
  "\n"
  "# Sequence number for this entry. Each entry has a unique sequence number which\n"
  "# monotonically increase, until integer overflow causes a wrap around.\n"
  "uint32 seq\n"
  "\n"
  "# The importance level of the log entry. Must be one of:\n"
  "# * TIER_UNINITIALIZED\n"
  "# * TIER_INFO\n"
  "# * TIER_WARNING\n"
  "# * TIER_ERROR\n"
  "string tier\n"
  "\n"
  "string TIER_UNINITIALIZED = \"uninitialized\"\n"
  "string TIER_INFO = \"info\"\n"
  "string TIER_WARNING = \"warning\"\n"
  "string TIER_ERROR = \"error\"\n"
  "\n"
  "# The timestamp of this log entry in the number of milliseconds since the beginning\n"
  "# of the Unix epoch. We use this instead of builtin_interfaces/Time to perfectly\n"
  "# match the log_entry.json schema.\n"
  "int64 unix_millis_time\n"
  "\n"
  "# The text of the log entry\n"
  "string text";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rmf_task_msgs__msg__LogEntry__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rmf_task_msgs__msg__LogEntry__TYPE_NAME, 26, 26},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 862, 862},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rmf_task_msgs__msg__LogEntry__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rmf_task_msgs__msg__LogEntry__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
